#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class bp3config:

    def save_password_toggled(self, widget):
        if not widget.get_active():
            self.t_udev_triggers_pppd.set_sensitive(False)
            self.t_udev_triggers_pppd.set_active(False)
        else:
            self.t_udev_triggers_pppd.set_sensitive(True)

    def connect(self, widget):
        gtk.main_quit()
        
    def cancel(self, widget):
        gtk.main_quit()
        
    def delete_event(self, widget, event, data=None):
        gtk.main_quit()
        return False

    def label(self, prompt, table, offset):
        label = gtk.Label(prompt)
        table.attach(label, 0, 1, offset, offset+1)
        label.show()
        
    def entry(self, prompt, table, offset):
        self.label(prompt, table, offset)
        entry = gtk.Entry()
        table.attach(entry, 1, 2, offset, offset+1)
        entry.show()
        return entry
    
    def __init__(self):
        self.w = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.w.set_title("bp3config")
        self.w.connect("delete_event", self.delete_event)
        self.w.set_border_width(10)

        tt = gtk.Tooltips()
        vb = gtk.VBox(False, 10)
        self.w.add(vb)

        ta = gtk.Table(3, 2, True)

        n = 0
        
        self.e_username = self.entry("Username : ", ta, n)
        tt.set_tip(self.e_username, "Enter your username for modem authentication, for BigPond service with APN telstra.bigpond use username@bigpond.com, for Telstra service with APN telstra.internet use anything.")
        # TODO: adopt default from bp3.conf
        
        self.e_password = self.entry("Password : ", ta, n+1)
        tt.set_tip(self.e_password, "Enter your password for modem authentication, for BigPond service use your BigPond password, for Telstra service use anything, it is ignored.")
        # TODO: adopt default from bp3.conf
        
        self.e_number   = self.entry("Number : ", ta, n+2)
        tt.set_tip(self.e_number, "Enter the number to dial to start the connection.  Normally this is *99#, because the default profile will have been set by the registration of the modem.  Alternative numbers are *99***1# to use profile number 1, *99***2# to use profile number 2, etc.")
        # TODO: adopt default from bp3.conf
        self.e_number.set_text("*99#")
        
        vb.pack_start(ta, True, True, 0)
        ta.show()
        
        self.t_save_password = gtk.CheckButton("Save password")
        self.t_save_password.set_active(True)
        # TODO: adopt default from bp3.conf
        # TODO: add save password feature to bp3.conf
        tt.set_tip(self.t_save_password, "Saves the password, which is required to enable automatic dialling.  It is saved in the file /etc/bp3.conf .")
        vb.pack_start(self.t_save_password, True, True, 0)
        self.t_save_password.connect("toggled", self.save_password_toggled)
        self.t_save_password.show()
        
        self.t_udev_triggers_pppd = gtk.CheckButton("Automatic dialling")
        # TODO: adopt default from bp3.conf
        # TODO: set sensitive only if t_save_password is active
        self.t_udev_triggers_pppd.set_active(True)
        tt.set_tip(self.t_udev_triggers_pppd, "The connection can be automatically started at the time the modem is plugged in to the computer.  This is the default.  With this feature turned off, the connection has to be started manually.")
        vb.pack_start(self.t_udev_triggers_pppd, True, True, 0)
        self.t_udev_triggers_pppd.show()

        self.t_debug = gtk.CheckButton("Debug output")
        tt.set_tip(self.t_debug, "Show more detail when trying to connect.  Useful for finding out why it doesn't work.  Adds the debug and dump options to the pppd command line.")
        vb.pack_start(self.t_debug, True, True, 0)
        self.t_debug.show()

        hbb = gtk.HButtonBox()
        self.b_connect = gtk.Button("Connect")
        self.b_connect.connect("clicked", self.connect)
        self.b_connect.show()
        hbb.add(self.b_connect)

        self.b_cancel = gtk.Button("Cancel")
        self.b_cancel.connect("clicked", self.cancel)
        self.b_cancel.show()
        hbb.add(self.b_cancel)
        hbb.show()
        vb.pack_start(hbb, True, True, 0)
        vb.show()
        self.w.show()

def main():
    gtk.main()

if __name__ == "__main__":
    # TODO: check if already connected and show a bp3connect() window instead
    ui = bp3config()
    main()

# TODO: option, "At the time the modem is plugged in or turned on", "do nothing", "prompt for password then connect", "connect using saved password"

# TODO: signal strength "information not available, please ask Maxon to release public specs about how to obtain signal strength during a call".

# TODO: why not use kppp?

